/******************************************************************************
 * MyOs	- my special operating system...
 *
 *
 * This is free. If you want to use and fix this program, you can do that...
 *
 * 
 * it's mine only for me...
 *
 * Inhyuk, Kim... kkojiband@hotmail.com
 *
 ******************************************************************************/


#include <Types.h>
#include <Kalloc.h>
#include <Ext2.h>
#include <Ide.h>
#include <String.h>


/* current partition  super block  Ѵ... */
static SuperBlock	mySuperBlock;

/* current partition  group descriptors  Ѵ... */
static GroupDesc	groupDesc[ BLOCK_SIZE / sizeof(GroupDesc) ];


void init_ext2( int baseSector )
{
	/* super block  Ѵ...! */
	read_ide( (char *)&mySuperBlock, baseSector+2, 2 );
	
	/* group descriptors  Ѵ...! */
	read_ide( (char *)groupDesc, baseSector+4, 2 );
}

InodeTable *get_inode_table( int inode )
{
	InodeTable	tables[4], *it;
	
	int	group, table, seq;
	

	/* inode  0  Ѵ...! */
	inode--;

	it	= (InodeTable *)kalloc( sizeof(InodeTable) );

	/*  group  inodesPerGroup ŭ inode  ϰ, ϳ 
	 * sector  4(128byte) inode  ...
	 */
	group	= inode / mySuperBlock.inodesPerGroup;
	table	= ( inode % mySuperBlock.inodesPerGroup ) / 4;
	seq		= ( inode % mySuperBlock.inodesPerGroup ) % 4;

	read_ide( (char *)tables, (groupDesc[group].inodeTable*2) + table, 1 );
	
	m_memcpy( it, tables+seq, sizeof(InodeTable) );

	return it;
}

void free_inode_table( InodeTable *it )
{
	kfree( it );
}

/* it  ϴ block    addr  Ѵ... */
int get_inode_blocks( char *addr, InodeTable *it )
{
	int	i;


	for( i = 0; i < 15; i++ )
	{
		if( !it->block[i] )
			break;

		read_ide( addr, it->block[i] * 2, 2 );

		addr	= addr + BLOCK_SIZE;
	}

	return 0;
}

/* directory  *offset ġ ִ file   Ѱְ, *offset 
 *  file  ġ ̵Ų...
 */
Entry *get_dir_entry_by_seq( Dentry *dentry, int *offset )
{
	Entry *entry;


	if( dentry->it->size <= *offset )
		return NULL;
	
	entry	= (Entry *)(dentry->addr + *offset);

	*offset	= *offset + entry->recLen;

	/*  file  name string   ڿ \0  ҴǾ  ʴ... */
	entry->name[entry->nameLen]	= '\0';

	return entry;
}

/* directory  name  شϴ file   Ѱش... */
Dentry *get_file( Dentry *dentry, char *name )
{
	Dentry	*child;
	Entry *entry;

	int	offset;


	child	= (Dentry *)kalloc( sizeof(Dentry) );
	if( child == NULL )
		return NULL;

	offset	= 0;

	while( (entry = get_dir_entry_by_seq( dentry, &offset )) != NULL )
	{
		if( !m_strcmp( entry->name, name ) )
		{
			child->inode	= entry->inode;
			child->it		= get_inode_table( child->inode );
			child->addr	= NULL;

			return child;
		}
	}
			
	kfree( child );

	return NULL;
}

int free_file( Dentry *dentry )
{
	if( dentry == NULL )
		return -1;

	free_inode_table( dentry->it );

	kfree( dentry );

	return 0;
}

/* inode  شϴ block  directory ̴.  directory   kernel 
 * cache  о̰, ٰϴ dentry  ؼ Ѱش...
 */
Dentry *get_directory( int inode )
{
	InodeTable	*it;
	Dentry	*dentry;

	
	dentry	= (Dentry *)kalloc( sizeof(Dentry) );
	if( dentry == NULL )
		return NULL;

	it	= get_inode_table( inode );

	dentry->inode	= inode;
	dentry->it		= it;
	dentry->addr	= (char *)alloc_kernel_cache();

	get_inode_blocks( dentry->addr, it );

	return dentry;
}

int free_directory( Dentry *dentry )
{
	if( dentry == NULL )
		return -1;
	
	free_inode_table( dentry->it );

	free_kernel_cache( dentry->addr );

	kfree( dentry );

	return 0;
}
