bits 32

%include "Util.inc"


extern handle_divide_error
extern handle_debug
extern handle_nmi
extern handle_breakpoint
extern handle_overflow
extern handle_bound_range_exceeded
extern handle_invalid_opcode
extern handle_nomath
extern handle_doublefault
extern handle_reserved_1
extern handle_invalid_tss
extern handle_segment_not_present
extern handle_stack_segment_fault
extern handle_general_protection
extern handle_page_fault
extern handle_reserved_2
extern handle_math_fault
extern handle_alignment_check
extern handle_machine_check
extern handle_floating_point_exception


section .text

	global ignore_int
	align 4
ignore_int:
	mov	edi, 0xc00b8000
	mov	al, 'X'
	stosb
	halt
	iret

handle_exception:
	SAVE_ALL

	mov	edx, [esp+36]
	call	edx
	
	RESTORE_ALL

	add	esp, 8
	iret

%macro exception_no_errorcode 2
	global %1
	align 4
%1:
	push	0x0
	push	%2
	jmp	handle_exception
%endmacro

%macro exception_errorcode 2
	global %1
	align 4
%1:
	push	%2
	jmp	handle_exception
%endmacro


exception_no_errorcode	divide_error, handle_divide_error
exception_no_errorcode	debug, handle_debug
exception_no_errorcode	nmi, handle_nmi
exception_no_errorcode	breakpoint, handle_breakpoint
exception_no_errorcode	overflow, handle_overflow
exception_no_errorcode	bound_range_exceeded, handle_bound_range_exceeded
exception_no_errorcode	invalid_opcode, handle_invalid_opcode
exception_no_errorcode	nomath, handle_nomath
exception_errorcode		doublefault, handle_doublefault
exception_no_errorcode	reserved_1, handle_reserved_1
exception_errorcode		invalid_tss, handle_invalid_tss
exception_errorcode		segment_not_present, handle_segment_not_present
exception_errorcode		stack_segment_fault, handle_stack_segment_fault	
exception_errorcode		general_protection, handle_general_protection
exception_errorcode		page_fault, handle_page_fault
exception_no_errorcode	reserved_2, handle_reserved_2
exception_no_errorcode	math_fault, handle_math_fault
exception_errorcode		alignment_check, handle_alignment_check
exception_no_errorcode	machine_check, handle_machine_check
exception_no_errorcode	floating_point_exception, handle_floating_point_exception

	global	ret_from_fork
	align 4
ret_from_fork:

	RESTORE_ALL
	iret
