/******************************************************************************
 * MyOs	- my special operating system...
 *
 *
 * This is free. If you want to use and fix this program, you can do that...
 *
 * 
 * it's mine only for me...
 *
 * Inhyuk, Kim... kkojiband@hotmail.com
 *
 ******************************************************************************/


#include <Irq.h>
#include <Types.h>
#include <Io.h>
#include <Idt.h>


extern void	not_ready_irq( void );

/* irq 2  ׻ enable · صд... */
static unsigned short	irqMask = 0xfffb;

#define	irqMask0_7	(unsigned char)(irqMask&0xff)
#define	irqMask8_15	(unsigned char)((irqMask>>8)&0xff)

/* hardware interrupt   ڵ鷯 ... */
static IrqHandler	irqHandler[MAX_IRQ];


void init_irq( void )
{
	int	i;

	
	/* hardware interrupt   interrupt base vector  Ѵ... */
	outb( 0x20, 0x11 );
	outb( 0xa0, 0x11 );
	
	outb( 0x21, IRQ_VECTOR );
	outb( 0xa1, IRQ_VECTOR+8 );
	
	outb( 0x21, 0x04 );
	outb( 0xa1, 0x02 );
	
	outb( 0x21, 0x01 );
	outb( 0xa1, 0x01 );
	
	/* irq 2    irq  disable Ѵ... */
	outb( 0x21, irqMask0_7 );
	outb( 0xa1, irqMask8_15 );

	
	for( i = 0; i < MAX_IRQ; i++ )
		irqHandler[i]	= not_ready_irq;
}

void enable_irq( int irq )
{
	irqMask	= irqMask & ~(1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

void disable_irq( int irq )
{
	irqMask	= irqMask | (1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

void register_irq_handler( int irq, IrqHandler handler )
{
	irqHandler[irq]	= handler;
}

void unregister_irq_handler( int irq )
{
	irqHandler[irq]	= NULL;
}

static int do_irq( int irq )
{
	/* eoi(end of interrupt)  ٷ Ѵ...
	 * ͷƮ óϴ  irqMask   ͷƮ Ѵ...
	 */
	if( irq & 8 )
	{
		inb( 0xa1 );
		outb( 0xa1, irqMask8_15 | (1<<irq) );
		outb( 0xa0, 0x60+(irq&7) );
		outb( 0x20, 0x62 );
	}
	else
	{
		inb( 0x21 );
		outb( 0x21, irqMask0_7 | (1<<irq) );
		outb( 0x20, 0x60+irq );
	}

	if( irqMask & (1<<irq) )
		return -1;

	irqMask	|= (1<<irq);

	/* ͷƮ ߻ ڵ ͷƮ ܵǹǷ װ ش... */
	sti();

	return 0;
}

static void end_irq( int irq )
{
	irqMask	&= ~(1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

void handle_irq( int irq )
{
	if( do_irq(irq) < 0 )
		return;
	
	/*  device driver   handler  ȣѴ... */
	irqHandler[irq]();

	end_irq( irq );
}
