/******************************************************************************
 * MyOs	- my special operating system...
 *
 *
 * This is free. If you want to use and fix this program, you can do that...
 *
 * 
 * it's mine only for me...
 *
 * Inhyuk, Kim... kkojiband@hotmail.com
 *
 ******************************************************************************/


#include <Types.h>
#include <Mem.h>
#include <Page.h>
#include <Kalloc.h>
#include <Process.h>


/* initPgd  Setup.asm  ϸ kernel  װ Ѵ...not good!
 */
unsigned int *initPgd = (unsigned int *)0xc0092000;


/* page frame descriptor... */
typedef struct _pageFrame	PageFrame;
struct _pageFrame
{
	unsigned int	flag;
	unsigned int	addr;
};

static PageFrame	*pageFrameTable;

/* process table, page directory, page table   kernel cache  Ѵ...
 */
static unsigned int	baseKernelCache		= (unsigned int)0xc0400000;
static unsigned int	currentKernelCache	= (unsigned int)0xc0400000;
static unsigned int	endKernelCache		= (unsigned int)0xc0800000;


void init_pgd( void )
{
	initPgd[0]	= 0;
	initPgd[1]	= 0;
}

void init_page_frame( void )
{
	int	i;

	
	pageFrameTable	=
				(PageFrame *)kalloc( sizeof(PageFrame) * howManyPhysMem<<8 );
	
	m_memset( pageFrameTable, 0, sizeof(PageFrame) * howManyPhysMem<<8 );
	
	for( i = 0; i < 0x800; i++ )
	{
		pageFrameTable[i].flag	|= KERNEL_USED;
		pageFrameTable[i].addr	= (i<<12) + KERNEL_PAGE_BASE;
	}
}

unsigned int alloc_page_frame( unsigned int addr, unsigned int flag )
{
	int	i;


	/* ߰:
	 * kernel  ûÿ 켱 ش...
	 * ҽ user  Ҵ page frame  켱 swap...
	 */
	
	for( i = 0x800; i < howManyPhysMem<<8; i++ )
	{
		if( !pageFrameTable[i].flag )
		{
			pageFrameTable[i].flag	|= flag;
			pageFrameTable[i].addr	= addr;

			return i<<12;
		}
	}

	return 0;
}

int free_page_frame( unsigned int phys )
{
	pageFrameTable[phys>>12].flag	= 0;
	pageFrameTable[phys>>12].addr	= 0;

	return 0;
}

/* physical addres -> linear address */
unsigned int get_addr_to_phys( unsigned int phys )
{
	return pageFrameTable[phys>>12].addr;
}
	
/* linear address -> physical address */
unsigned int get_phys_to_addr( unsigned int addr )
{
	unsigned int *pgd = (unsigned int *)current->thread.cr3;
	unsigned int *pte;
	
	
	if( !(pgd[PGD_OFFSET(addr)] & PAGE_PRESENT_FLAG) )
		return 0;
	
	pte	= (unsigned int *)
		get_addr_to_phys( pgd[PGD_OFFSET(addr)] & 0xfffff000 );

	if( !(pte[PTE_OFFSET(addr)] & PAGE_PRESENT_FLAG) )
		return 0;

	return pte[PTE_OFFSET(addr)] & 0xfffff000;
}

static void update_kernel_cache( void )
{
	ProcessTable	*p;
	
	unsigned int *pte;
	unsigned int phys, addr;
	
	int	i;
	

	addr	= endKernelCache - PAGE_SIZE;
	
	phys	= get_phys_to_addr( addr );

	pte	= (unsigned int *)addr;
		
	p	= initProcess;

	/* kernel page global directory κ  μ ϰ 
	 * ؾѴ...
	 */
	do
	{
		((unsigned int *)p->thread.cr3)[PGD_OFFSET(endKernelCache)]	=
								phys | PAGE_WRITE_FLAG | PAGE_PRESENT_FLAG;
		
		p	= LIST_ENTRY( p->running.next, ProcessTable, running );
		
	} while( p != initProcess );
		
	
	for( i = 0; i < 1024; i++ )
	{
		pte[i]	= alloc_page_frame( addr, KERNEL_USED ) | PAGE_PRESENT_FLAG;
		
		addr	+= 0x1000;
	}

	currentKernelCache	= endKernelCache;
	
	endKernelCache	= endKernelCache + 0x400000;
}
	
/* kernel cache  ̸  ũ  Ȯ , PAGE_WRITE_FLAG 
 * ؼ  θ ǺѴ.  Ư  ߻ ʴ 
 *  Ǹ,  ϰ  (!)  ϱ⿡ ׳  ...
 */
unsigned int alloc_kernel_cache( void )
{
	unsigned int *pgd = (unsigned int *)current->thread.cr3;
	unsigned int *pte, addr;
	

	/* currentKernelCache  kernel cache  밡 page  
	 *   ġ page  base address   ִ...
	 */
	pte	= (unsigned int *)
		get_addr_to_phys( pgd[PGD_OFFSET(currentKernelCache)] & 0xfffff000 );
	
	pte[PTE_OFFSET(currentKernelCache)]	|= PAGE_WRITE_FLAG;
	
	addr	= currentKernelCache;
	
	/* kernel cache  currentKernelCache  ġ 밡 page 
	 * base address  ٽ currentKernelCache  ...
	 *  ٸ update_kernel_cache()  ȣؼ ο kernel cache 
	 * Ҵ޴´...
	 */
	if( currentKernelCache != ( endKernelCache - PAGE_SIZE*2 ) )
	{
		unsigned int next = currentKernelCache;

		while( next < ( endKernelCache - PAGE_SIZE*2 ) )
		{
			if( !(pte[PTE_OFFSET(next)] & PAGE_WRITE_FLAG) )
				break;

			next	+= PAGE_SIZE;
		}

		currentKernelCache	= next;
	}
	else
		update_kernel_cache();

	return addr;
}

int free_kernel_cache( unsigned int addr )
{
	unsigned int *pgd = (unsigned int *)current->thread.cr3;
	unsigned int *pte;


	pte	= (unsigned int *)get_addr_to_phys(pgd[PGD_OFFSET(addr)] & 0xfffff000);
	
	pte[PTE_OFFSET(addr)]	&= ~PAGE_WRITE_FLAG;
	
	if( currentKernelCache > addr )
		currentKernelCache	= addr;
}

int alloc_page( unsigned int addr, unsigned int flag )
{
	unsigned int *pgd = (unsigned int *)current->thread.cr3;
	unsigned int *pte, phys;
	
	
	if( !(pgd[PGD_OFFSET(addr)] & PAGE_PRESENT_FLAG) )
	{
		phys = get_phys_to_addr( alloc_kernel_cache() );
		
		if( !phys )
			return -1;
		pgd[PGD_OFFSET(addr)]	= phys | flag | PAGE_PRESENT_FLAG;
	}

	pte	= (unsigned int *)
		get_addr_to_phys( pgd[PGD_OFFSET(addr)] & 0xfffff000 );
	
	if( pte[PTE_OFFSET(addr)] & PAGE_PRESENT_FLAG )
		return -1;

	phys = alloc_page_frame( addr & 0xfffff000,
							(addr<KERNEL_PAGE_BASE) ? USER_USED : KERNEL_USED);
	if( !phys )
		return -1;
	pte[PTE_OFFSET(addr)]	= phys | flag | PAGE_PRESENT_FLAG
							| ( (addr<KERNEL_PAGE_BASE) ? USER_USED : 0 );

	return 0;
}
	

int free_page( unsigned int addr )
{
	unsigned int *pgd = (unsigned int *)current->thread.cr3;
	unsigned int *pte;


	if( !(pgd[PGD_OFFSET(addr)] & PAGE_PRESENT_FLAG) )
		return -1;
	
	pte	= (unsigned int *)
		get_addr_to_phys( pgd[PGD_OFFSET(addr)] & 0xfffff000 );

	if( !(pte[PTE_OFFSET(addr)] & PAGE_PRESENT_FLAG) )
		return -1;

	free_page_frame( pte[PTE_OFFSET(addr)] & 0xfffff000 );

	pte[PTE_OFFSET(addr)]	= 0;

	return 0;
}

/* page fault handler... */
void handle_page_fault( RegsInStack regs )
{
	unsigned int	cr2;


	/* ޸𸮿  ٽ   ʾƵ NON_WRITE_FLAG  
	 *  ȴ...!
	 */
	
	asm __volatile__ (
			"movl %%cr2, %0\n"
			: "=r" (cr2) );
	
	alloc_page( cr2, PAGE_WRITE_FLAG );
}
