bits 16
org	0x9000
	
	mov	ax, cs
	mov	ds, ax


	; enable a20...
	call	enable_a20

	; enable protected mode...
	mov	ax, 0x9000
	mov	es, ax

	xor	di, di
	mov	si, gdt
	xor	ecx, ecx
	mov	cx, 0x18
	rep	movsw
	
	cli

	lidt	[idtr]
	lgdt	[gdtr]
	
	mov	eax, cr0
	or	al, 1
	mov	cr0, eax
	
	mov	ax, 0x10
	mov	ds, ax
	mov	es, ax
	mov	fs, ax
	mov	gs, ax
	mov	ss, ax
	
	jmp	dword 0x8:in_protected

; enable a20...
enable_a20:
_enable_a20_1:
	in	al, 0x64
	test	al, 2
	jnz	_enable_a20_1
	mov	al, 0xd1
	out	0x64, al
	
_enable_a20_2:
	in	al, 0x64
	test	al, 2
	jnz	_enable_a20_2
	mov	al, 0xdf
	out	0x60, al
	ret


bits 32

in_protected:

	; get total physical memory
	xor	edi, edi
	mov	al, 'Q'

_1:	mov	[edi], al
	cmp	byte[edi], 'Q'
	jnz	_2
	add	edi, 0x100000
	jmp	_1
_2:	mov	edx, edi
	shr	edx, 20


	xor	ecx, ecx

	; setup page table...
	mov	edi, 0x92000
	xor	eax, eax
	mov	cx, 3072
	rep	stosd
	
	mov	edi, 0x92000
	mov	eax, 0x93003
	stosd
	mov	eax, 0x94003
	stosd

	mov	edi, 0x92c00
	mov	eax, 0x93003
	stosd
	mov	eax, 0x94003
	stosd

	mov	edi, 0x93000
	xor	eax, eax
	or	eax, 0x3
	
	mov	cx, 1024
_3:	stosd
	add	eax, 0x1000
	dec	cx
	jnz	_3


	and	eax, 0xfffff000
	or	eax, 0x1

	mov	cx, 1024
_4:	stosd
	add	eax, 0x1000
	dec	cx
	jnz	_4

	mov	eax, 0x92000
	mov	cr3, eax

	mov	eax, cr0
	or	eax, 0x80000000
	mov	cr0, eax

	jmp 0xc0009200


gdt:	dw 0, 0, 0, 0

		dw 0xffff, 0, 0x9a00, 0xcf	
		dw 0xffff, 0, 0x9200, 0xcf

		dw 0, 0, 0, 0
		
		dw 0xffff, 0, 0xfa00, 0xcf	
		dw 0xffff, 0, 0xf200, 0xcf

gdtr:	dw 0x1000
		dd 0x90000

idtr:	dw 0x1000
		dd 0x91000


	times 512-($-$$) db 0
